package com.lancoo.track.comprehensive.service.impl;

package ..deTemp.1729408215970;

import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.druid.util.StringUtils;
import com.alibaba.ttl.threadpool.TtlExecutors;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.google.common.collect.Lists;
import com.lancoo.track.common.core.common.exception.BaseException;
import com.lancoo.track.common.core.component.SchoolIDRequestContext;
import com.lancoo.track.common.core.entity.dto.StateDTO;
import com.lancoo.track.common.core.entity.dto.WebDeviceEntity;
import com.lancoo.track.common.core.entity.dto.WebUserInfo;
import com.lancoo.track.common.core.entity.middle.SchoolAreaDistribution;
import com.lancoo.track.common.core.enums.ActionTypeEnum;
import com.lancoo.track.common.core.enums.AreaTypeEnum;
import com.lancoo.track.common.core.enums.DeviceTypeEnum;
import com.lancoo.track.common.core.enums.EventTypeEnum;
import com.lancoo.track.common.core.enums.ResultStatus;
import com.lancoo.track.comprehensive.entity.po.SetDeviceDeployment;
import com.lancoo.track.comprehensive.entity.po.SetNvrHost;
import com.lancoo.track.comprehensive.entity.po.SourceUserTrail;
import com.lancoo.track.comprehensive.entity.po.StuAbnormalActionAlarm;
import com.lancoo.track.comprehensive.entity.vo.action.ActionDataVO;
import com.lancoo.track.comprehensive.mapper.SetDeviceDeploymentMapper;
import com.lancoo.track.comprehensive.mapper.SetNvrHostMapper;
import com.lancoo.track.comprehensive.mapper.SourceUserTrailMapper;
import com.lancoo.track.comprehensive.mapper.StuAbnormalActionAlarmMapper;
import com.lancoo.track.comprehensive.service.AbnormalManageService;
import com.lancoo.track.comprehensive.service.ActionManageService;
import com.lancoo.track.comprehensive.service.AreaDeviceInforService;
import com.lancoo.track.comprehensive.service.CountUserSchoolService;
import com.lancoo.track.comprehensive.service.PushDataService;
import com.lancoo.track.comprehensive.third.entity.ThirdAreaDto;
import com.lancoo.track.comprehensive.third.service.ThirdService;
import com.lancoo.track.comprehensive.utils.ObjFillUtils;
import com.lancoo.track.comprehensive.utils.ResourceDownloadUtils;
import com.lancoo.track.comprehensive.utils.ServiceUtils;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.redisson.api.RBlockingQueue;
import org.redisson.api.RedissonClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ActionManageServiceImpl implements ActionManageService {
  private static final Logger logger = LoggerFactory.getLogger(com.lancoo.track.comprehensive.service.impl.ActionManageServiceImpl.class);
  
  @Resource
  SourceUserTrailMapper sourceUserTrailMapper;
  
  @Resource
  AreaDeviceInforService areaDeviceInforService;
  
  @Resource
  SetDeviceDeploymentMapper setDeviceDeploymentMapper;
  
  @Resource
  StuAbnormalActionAlarmMapper stuAbnormalActionAlarmMapper;
  
  @Resource
  SetNvrHostMapper setNvrHostMapper;
  
  @Autowired
  PushDataService pushDataService;
  
  @Resource
  ThirdService thirdService;
  
  @Resource
  AbnormalManageService abnormalManageService;
  
  @Resource
  CountUserSchoolService countUserSchoolService;
  
  @Resource
  ResourceDownloadUtils resourceDownloadUtils;
  
  public static ExecutorService executorService = Executors.newFixedThreadPool(4);
  
  @Autowired
  private RedissonClient redissonClient;
  
  @Autowired
  private ServiceUtils serviceUtils;
  
  static {
    executorService = TtlExecutors.getTtlExecutorService(executorService);
  }
  
  public List addActive(Map paramMap) {
    List<Map> data;
    String eventFlag, str1, sysID = (String)paramMap.get("SysID");
    Set<ActionDataVO> addParamList = new LinkedHashSet<>();
    switch (sysID) {
      case "861":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->计算端推送数据接收： {} 条", Integer.valueOf(data.size()));
        data.forEach(param -> {
              if (param != null) {
                List<SetDeviceDeployment> allCameraInfor;
                ActionDataVO actionDataVO = new ActionDataVO();
                String blacklistUserName = (String)param.get("BlacklistUserName");
                actionDataVO.setBlacklistUserName(blacklistUserName);
                actionDataVO.setSchoolID((String)param.get("schoolID"));
                if (param.get("StudentID") != null) {
                  actionDataVO.setUserId((String)param.get("StudentID"));
                } else if (param.get("TeacherId") != null) {
                  actionDataVO.setUserId((String)param.get("TeacherId"));
                } else if (param.get("PersonID") != null) {
                  actionDataVO.setUserId((String)param.get("PersonID"));
                } else if (param.get("UserID") != null) {
                  actionDataVO.setUserId((String)param.get("UserID"));
                } 
                actionDataVO.setSimilarity((String)param.get("Similarity"));
                actionDataVO.setActionTime((String)param.get("Photograph_Time"));
                actionDataVO.setActionPic((String)param.get("Photograph_ImgUrl"));
                actionDataVO.setSysId("861");
                try {
                  String schoolID = (String)param.get("schoolID");
                  schoolID = getSchoolID(schoolID);
                  if (StrUtil.isBlank(schoolID)) {
                    logger.info("addActive--未获取到schoolID");
                    return;
                  } 
                  SchoolIDRequestContext.setSchoolIDLocal(schoolID);
                  allCameraInfor = this.setDeviceDeploymentMapper.getAllCameraInfo();
                } finally {
                  SchoolIDRequestContext.remove();
                } 
                boolean flag = false;
                for (SetDeviceDeployment camera : allCameraInfor) {
                  if (StringUtils.equals(camera.getDeviceIp(), (String)param.get("WebcamIP"))) {
                    if (!flag) {
                      actionDataVO.setDeviceId(camera.getDeviceId());
                      actionDataVO.setActionType(camera.getBackAndForth());
                      addParamList.add(actionDataVO);
                      flag = true;
                      continue;
                    } 
                    try {
                      ActionDataVO actionDataVO1 = (ActionDataVO)actionDataVO.clone();
                      actionDataVO1.setDeviceId(camera.getDeviceId());
                      actionDataVO1.setActionType(camera.getBackAndForth());
                      addParamList.add(actionDataVO1);
                    } catch (CloneNotSupportedException e) {
                      logger.error("【addActive】克隆错误：", e);
                    } 
                  } 
                } 
              } 
            });
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "E48":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->智能寝室推送数据接收： {} 条", Integer.valueOf(data.size()));
        data.forEach(param -> {
              ActionDataVO actionDataVO = new ActionDataVO();
              actionDataVO.setSchoolID((String)param.get("schoolID"));
              if (param.get("StudentID") != null) {
                actionDataVO.setUserId((String)param.get("StudentID"));
              } else if (param.get("TeacherId") != null) {
                actionDataVO.setUserId((String)param.get("TeacherId"));
              } else if (param.get("PersonID") != null) {
                actionDataVO.setUserId((String)param.get("PersonID"));
              } else if (param.get("UserID") != null) {
                actionDataVO.setUserId((String)param.get("UserID"));
              } 
              actionDataVO.setActionTime((String)param.get("RecordTime"));
              actionDataVO.setDeviceId((String)param.get("EquipmentID"));
              actionDataVO.setActionType(Integer.valueOf((Integer.parseInt(param.get("ThroughStatus").toString()) == 0) ? 1 : 2));
              actionDataVO.setSysId("E48");
              addParamList.add(actionDataVO);
            });
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "E53":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->智慧操场推送数据接收： {} 条", Integer.valueOf(data.size()));
        data.forEach(param -> {
              ActionDataVO actionDataVO = new ActionDataVO();
              actionDataVO.setSchoolID((String)param.get("schoolID"));
              actionDataVO.setUserId((String)param.get("Distinguish_UserID"));
              actionDataVO.setActionTime((String)param.get("Distinguish_Time"));
              actionDataVO.setDeviceId((String)param.get("EquipID"));
              actionDataVO.setActionType(Integer.valueOf(1));
              actionDataVO.setSysId("E53");
              addParamList.add(actionDataVO);
            });
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "E35":
        data = (List<Map>)paramMap.get("EventData");
        logger.info("->->智能考勤推送数据接收： {} 条", Integer.valueOf(data.size()));
        eventFlag = (String)paramMap.get("EventFlag");
        switch (eventFlag.substring(0, 3)) {
          case "M11":
            data.forEach(param -> {
                  ActionDataVO actionDataVO = new ActionDataVO();
                  actionDataVO.setSchoolID((String)param.get("schoolID"));
                  actionDataVO.setUserId((String)param.get("UserID"));
                  actionDataVO.setActionTime((String)param.get("InOrOutTime"));
                  actionDataVO.setDeviceId((String)param.get("MachineID"));
                  actionDataVO.setActionType(Integer.valueOf((Integer.parseInt(param.get("InOrOutType").toString()) == 0) ? 1 : 2));
                  actionDataVO.setSysId("E24");
                  addParamList.add(actionDataVO);
                });
            logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
            queue = this.redissonClient.getBlockingQueue("doAddActive");
            queue.add(addParamList);
            return null;
          case "M38":
            data.forEach(param -> {
                  ActionDataVO actionDataVO = new ActionDataVO();
                  actionDataVO.setSchoolID((String)param.get("schoolID"));
                  actionDataVO.setUserId((String)param.get("PersonID"));
                  actionDataVO.setActionTime((String)param.get("InOrOutTime"));
                  actionDataVO.setAreaId((String)param.get("AddressID"));
                  actionDataVO.setDeviceId((String)param.get("MachineID"));
                  actionDataVO.setActionType(Integer.valueOf((Integer.parseInt(param.get("InOrOutType").toString()) == 0) ? 1 : 2));
                  actionDataVO.setSysId("E24");
                  addParamList.add(actionDataVO);
                });
            logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
            queue = this.redissonClient.getBlockingQueue("doAddActive");
            queue.add(addParamList);
            return null;
        } 
        logger.info("轨迹信息插入失败：" + ResultStatus.CODE_502.code, ResultStatus.CODE_502.msg + "[eventFlag]");
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "E33":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->学情分析推送数据接收： {} 条", Integer.valueOf(data.size()));
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "E36":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->班牌推送数据接收： {} 条", Integer.valueOf(data.size()));
        data.forEach(param -> {
              ActionDataVO actionDataVO = new ActionDataVO();
              actionDataVO.setSchoolID((String)param.get("schoolID"));
              actionDataVO.setUserId((String)param.get("UserID"));
              actionDataVO.setActionTime((String)param.get("CollectTime"));
              if (!StringUtils.isEmpty((String)param.get("ImgUrl")))
                actionDataVO.setActionPic((String)param.get("ImgUrl")); 
              if (!StringUtils.isEmpty((String)param.get("VideoUrl")))
                actionDataVO.setActionMov((String)param.get("VideoUrl")); 
              actionDataVO.setActionType(Integer.valueOf(1));
              actionDataVO.setSysId("E36");
              actionDataVO.setDeviceId((String)param.get("DeviceID"));
              addParamList.add(actionDataVO);
            });
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
      case "third":
        data = (List<Map>)paramMap.get("Data");
        logger.info("->->第三方设备推送数据接收： {} 条", Integer.valueOf(data.size()));
        data.forEach(param -> {
              ActionDataVO actionDataVO = new ActionDataVO();
              actionDataVO.setSchoolID((String)param.get("schoolID"));
              actionDataVO.setUserId((String)param.get("userID"));
              actionDataVO.setActionTime((String)param.get("actionTime"));
              actionDataVO.setActionPic((String)param.get("actionPic"));
              actionDataVO.setActionMov((String)param.get("actionMov"));
              actionDataVO.setActionType(Integer.valueOf((Integer.parseInt(param.get("InOrOutType").toString()) == 0) ? 1 : 2));
              actionDataVO.setDeviceId((String)param.get("deviceID"));
              actionDataVO.setSysId("third");
              addParamList.add(actionDataVO);
            });
        logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
        queue = this.redissonClient.getBlockingQueue("doAddActive");
        queue.add(addParamList);
        return null;
    } 
    logger.info("轨迹信息插入失败：" + ResultStatus.CODE_502.code, ResultStatus.CODE_502.msg + " [SysID] 错误，请传递推送系统ID");
    logger.info("接收轨迹信息：【{}】", addParamList.stream().map(ActionDataVO::getUserId).collect(Collectors.toList()));
    RBlockingQueue<Set<ActionDataVO>> queue = this.redissonClient.getBlockingQueue("doAddActive");
    queue.add(addParamList);
    return null;
  }
  
  private String getSchoolID(String schoolID) {
    if (StrUtil.isBlank(schoolID)) {
      HashMap<String, Object> map = this.serviceUtils.getMultiFlagAndSchoolIDByCache();
      if (MapUtil.isNotEmpty(map) && !((Boolean)map.get("is_multi")).booleanValue()) {
        String s = (String)map.get("schoolID");
        if (StrUtil.isNotBlank(s))
          schoolID = s; 
      } 
    } 
    return schoolID;
  }
  
  public List doAddActive(Set<ActionDataVO> actionDataVOList) throws InterruptedException {
    String schoolID = actionDataVOList.stream().map(ActionDataVO::getSchoolID).filter(Objects::nonNull).findAny().orElse(null);
    schoolID = getSchoolID(schoolID);
    if (StrUtil.isBlank(schoolID)) {
      logger.info("doAddActive--未获取到schoolID");
      return Lists.newArrayList();
    } 
    SchoolIDRequestContext.setSchoolIDLocal(schoolID);
    logger.info("接收推送数据大小：{}", Integer.valueOf(actionDataVOList.size()));
    List<Map<Object, Object>> result = new ArrayList();
    List<StuAbnormalActionAlarm> pushData = new ArrayList();
    for (ActionDataVO actionData : actionDataVOList) {
      Map<Object, Object> rep = new HashMap<>();
      WebDeviceEntity deviceInfor = null;
      if (StringUtils.isEmpty(actionData.getDeviceId())) {
        logger.error("轨迹信息插入失败（设备ID为空）-->actionData={}", actionData);
        continue;
      } 
      deviceInfor = this.areaDeviceInforService.getDeviceInforById(schoolID, actionData.getDeviceId(), actionData.getSysId(), actionData.getActionType());
      if (deviceInfor == null) {
        logger.error("轨迹信息插入失败（设备信息查找失败）-->actionData={}", actionData);
        continue;
      } 
      if (!StringUtils.isEmpty(actionData.getUserId())) {
        WebUserInfo userInfor = null;
        try {
          userInfor = this.thirdService.getUserInforById(schoolID, actionData.getUserId());
        } catch (BaseException e) {
          logger.info("轨迹信息插入失败(用户查询失败)：" + e.getMsg());
          continue;
        } 
        if (userInfor != null) {
          SourceUserTrail sourceUserTrail = new SourceUserTrail();
          sourceUserTrail.setUserid(actionData.getUserId());
          sourceUserTrail.setCollecttime(Timestamp.valueOf(actionData.getActionTime()));
          sourceUserTrail.setActivetype(actionData.getActionType());
          sourceUserTrail.setSysid(actionData.getSysId());
          sourceUserTrail.setUsertype(userInfor.getUserType());
          System.out.println(userInfor.getUserType());
          if (!StringUtils.isEmpty(actionData.getDeviceId())) {
            sourceUserTrail.setAreaid(deviceInfor.getAreaId());
            sourceUserTrail.setDeviceid(actionData.getDeviceId());
          } 
          if (!StringUtils.isEmpty(deviceInfor.getBuildingFloor()))
            sourceUserTrail.setLevel(Integer.valueOf(Integer.parseInt(deviceInfor.getBuildingFloor()))); 
          SchoolAreaDistribution thirdArea = this.thirdService.getAreaInforById(schoolID, sourceUserTrail.getAreaid());
          if (thirdArea == null) {
            logger.error("轨迹插入失败，轨迹区域不存在！数据为:{}", actionData);
            continue;
          } 
          int areaType = getAreaType(sourceUserTrail.getAreaid());
          if (areaType == 0) {
            logger.info("过滤掉学生轨迹：{}-{}：区域不存在 areaId={}", new Object[] { userInfor.getUserId(), userInfor.getUserName(), sourceUserTrail.getAreaid() });
            continue;
          } 
          Map<String, StateDTO> map = new HashMap<>();
          StateDTO setstate = new StateDTO();
          try {
            switch (actionData.getSysId()) {
              case "E24":
                switch (actionData.getPlaceType().intValue()) {
                  case 11:
                    sourceUserTrail.setActivetype(Integer.valueOf(2));
                    setstate.setState(Integer.valueOf((actionData.getActionType().intValue() == 1) ? 2 : 4));
                    setstate.setLastAreaId(sourceUserTrail.getAreaid());
                    setstate.setLastActiveTime(actionData.getActionTime());
                    map.put(sourceUserTrail.getUserid(), setstate);
                    this.countUserSchoolService.pushState(map);
                    break;
                  case 1:
                  case 2:
                  case 3:
                  case 4:
                  case 15:
                  case 31:
                    sourceUserTrail.setActivetype(Integer.valueOf(1));
                    setstate.setState(Integer.valueOf(3));
                    setstate.setLastAreaId(sourceUserTrail.getAreaid());
                    setstate.setLastActiveTime(actionData.getActionTime());
                    map.put(sourceUserTrail.getUserid(), setstate);
                    this.countUserSchoolService.pushState(map);
                    break;
                } 
                setstate.setState(Integer.valueOf((actionData.getActionType().intValue() == 1) ? 3 : 2));
                setstate.setLastAreaId(sourceUserTrail.getAreaid());
                setstate.setLastActiveTime(actionData.getActionTime());
                map.put(sourceUserTrail.getUserid(), setstate);
                this.countUserSchoolService.pushState(map);
                break;
              default:
                switch (actionData.getActionType().intValue()) {
                  case 1:
                    setstate.setState(Integer.valueOf(3));
                    setstate.setLastAreaId(sourceUserTrail.getAreaid());
                    setstate.setLastActiveTime(actionData.getActionTime());
                    map.put(sourceUserTrail.getUserid(), setstate);
                    this.countUserSchoolService.pushState(map);
                    break;
                  case 11:
                    sourceUserTrail.setActivetype(Integer.valueOf(2));
                    setstate.setState(Integer.valueOf(4));
                    setstate.setLastAreaId(sourceUserTrail.getAreaid());
                    setstate.setLastActiveTime(actionData.getActionTime());
                    map.put(sourceUserTrail.getUserid(), setstate);
                    this.countUserSchoolService.pushState(map);
                    break;
                  case 20:
                    sourceUserTrail.setActivetype(Integer.valueOf(1));
                    setstate.setState(Integer.valueOf(3));
                    setstate.setLastAreaId(sourceUserTrail.getAreaid());
                    setstate.setLastActiveTime(actionData.getActionTime());
                    map.put(sourceUserTrail.getUserid(), setstate);
                    this.countUserSchoolService.pushState(map);
                    break;
                } 
                setstate.setState(Integer.valueOf(2));
                setstate.setLastAreaId(sourceUserTrail.getAreaid());
                setstate.setLastActiveTime(actionData.getActionTime());
                map.put(sourceUserTrail.getUserid(), setstate);
                this.countUserSchoolService.pushState(map);
                break;
            } 
          } catch (BaseException e) {
            logger.error("推送状态模块出错，{}，原因为：", actionData, e);
          } catch (RuntimeException e) {
            logger.error("更新失败，{}，原因为：", actionData, e);
          } 
          boolean rightSource = false;
          if (sourceUserTrail.getActivetype().intValue() == 1 || sourceUserTrail.getActivetype().intValue() == 2) {
            sourceUserTrail.setCreateTime(new Date());
            sourceUserTrail.setCreator("");
            this.sourceUserTrailMapper.insert(sourceUserTrail);
            rightSource = true;
          } 
          rep.put("userId", sourceUserTrail.getUserid());
          rep.put("actionType", sourceUserTrail.getActivetype());
          result.add(rep);
          if (sourceUserTrail.getUsertype().intValue() == 2) {
            StuAbnormalActionAlarm stuAbnormalActionAlarm1 = null;
            try {
              stuAbnormalActionAlarm1 = this.abnormalManageService.checkAbnormal(actionData, userInfor, deviceInfor, sourceUserTrail, rightSource);
            } catch (Throwable e) {
              logger.error("异常检测出错", e);
            } 
            if (stuAbnormalActionAlarm1 == null);
          } 
          continue;
        } 
        if (!StringUtils.isEmpty(actionData.getUserId()))
          logger.info("过滤掉：用户不存在 userInfor=" + actionData.getUserId()); 
        continue;
      } 
      if (ignoreThisAbnormal(actionData.getDeviceId(), actionData.getActionTime(), actionData.getActionType()))
        continue; 
      String downFlag = "861";
      StuAbnormalActionAlarm stuAbnormalActionAlarm = new StuAbnormalActionAlarm();
      stuAbnormalActionAlarm.setAlarmAreaId(deviceInfor.getAreaId());
      stuAbnormalActionAlarm.setAlarmAreaName(deviceInfor.getAreaName());
      stuAbnormalActionAlarm.setAlarmState(Integer.valueOf(0));
      stuAbnormalActionAlarm.setAlarmDeviceId(deviceInfor.getThirdDeviceId());
      stuAbnormalActionAlarm.setAlarmRelatePic(actionData.getActionPic());
      stuAbnormalActionAlarm.setAlarmTime(Timestamp.valueOf(actionData.getActionTime()));
      stuAbnormalActionAlarm.setAlarmTypeId(actionData.getActionType());
      stuAbnormalActionAlarm.setAlarmTypeName(ActionTypeEnum.getNameByKey(actionData.getActionType()));
      stuAbnormalActionAlarm.setCreator("");
      if (actionData.getActionType().equals(ActionTypeEnum.CODE3.code)) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似攀墙");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到攀爬围墙危险异常");
      } else if (actionData.getActionType().equals(ActionTypeEnum.CODE4.code)) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似涉水");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到涉水危险异常");
      } else if (actionData.getActionType().equals(ActionTypeEnum.CODE5.code)) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似聚集");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + (StringUtils.isEmpty(deviceInfor.getBuildingFloor()) ? "" : (deviceInfor.getBuildingFloor() + "楼")) + "检测到室内人员聚集异常");
      } else if (actionData.getActionType().equals(ActionTypeEnum.CODE21.code)) {
        stuAbnormalActionAlarm.setAlarmSubject("疑似徘徊");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到徘徊异常");
      } else if (actionData.getActionType().equals(ActionTypeEnum.CODE22.code)) {
        downFlag = "other";
        stuAbnormalActionAlarm.setAlarmSubject("疑似欺凌");
        stuAbnormalActionAlarm.setAlarmRelatePic(null);
        stuAbnormalActionAlarm.setAlarmRelateMov(null);
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + (StringUtils.isEmpty(deviceInfor.getBuildingFloor()) ? "" : (deviceInfor.getBuildingFloor() + "楼")) + "检测到欺凌异常");
        if (DeviceTypeEnum.CODE9.getCode().equals(deviceInfor.getDeviceType()))
          stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getDeviceName() + "检测到欺凌异常"); 
      } else if (StrUtil.isNotBlank(actionData.getBlacklistUserName())) {
        stuAbnormalActionAlarm.setAlarmTypeId(ActionTypeEnum.CODE23.getCode());
        stuAbnormalActionAlarm.setAlarmTypeName(ActionTypeEnum.CODE23.getMsg());
        stuAbnormalActionAlarm.setAlarmSubject("疑似黑名单人员活动");
        stuAbnormalActionAlarm.setAlarmDescription("" + actionData.getActionTime() + deviceInfor.getAreaName() + "检测到黑名单人员" + actionData.getBlacklistUserName());
      } else {
        continue;
      } 
      this.stuAbnormalActionAlarmMapper.insert(stuAbnormalActionAlarm);
      if ("861".equals(downFlag)) {
        SetDeviceDeployment schoolDeviceDeployment = this.setDeviceDeploymentMapper.selectByIdAndActionType(actionData.getDeviceId(), actionData.getActionType());
        SetNvrHost recordHost = (SetNvrHost)this.setNvrHostMapper.selectOne((Wrapper)((QueryWrapper)(new QueryWrapper()).eq("host_ip", schoolDeviceDeployment.getRecordServerIp())).and(wrapper -> (QueryWrapper)((QueryWrapper)((QueryWrapper)wrapper.eq("creator", "1")).or()).eq("1", "1")));
        this.resourceDownloadUtils.downloadVideoByActionTask(schoolDeviceDeployment, recordHost, Timestamp.valueOf(actionData.getActionTime()), stuAbnormalActionAlarm.getStudentAlarmId());
      } else if ("other".equals(downFlag)) {
        String calculateAddress = ObjFillUtils.getCalculateAddress();
        if (ActionTypeEnum.CODE22.code.equals(actionData.getActionType())) {
          if ("861".equals(actionData.getSysId())) {
            String isSuccess = this.thirdService.syncAbnormalPicUri(calculateAddress, actionData.getActionPic(), "", actionData.getSysId(), EventTypeEnum.emergencyEvent.getKey(), actionData.getActionTime(), null);
            logger.info("【防欺凌异常】-{}-同步视频图片路径：{}", stuAbnormalActionAlarm.getStudentAlarmId(), isSuccess);
            if (isSuccess != null && !Objects.equals("track_calculate", isSuccess)) {
              String[] urlArr = isSuccess.split(",");
              if (urlArr.length == 1 && !Objects.equals("null", urlArr[0])) {
                stuAbnormalActionAlarm.setAlarmRelatePic(urlArr[0]);
                this.stuAbnormalActionAlarmMapper.updateAlarmRelatePicAndAlarmRelateMov(stuAbnormalActionAlarm);
              } 
            } 
          } 
          if ("E01".equals(actionData.getSysId())) {
            String sysId = "E57";
            String actionTimeOfCode22 = actionData.getActionTime().replaceAll("[^0-9]", "");
            String actionPicOfCode22 = actionData.getActionPic();
            String actionMovOfCode22 = actionData.getActionMov();
            if (StrUtil.isNotBlank(calculateAddress) && StrUtil.isNotBlank(actionTimeOfCode22) && StrUtil.isNotBlank(actionPicOfCode22) && StrUtil.isNotBlank(actionMovOfCode22)) {
              String isSuccess = this.thirdService.syncAbnormalPicUri(calculateAddress, actionPicOfCode22, actionMovOfCode22, sysId, EventTypeEnum.emergencyEvent.getKey(), actionTimeOfCode22, null);
              logger.info("【防欺凌异常】-{}-同步视频图片路径：{}", stuAbnormalActionAlarm.getStudentAlarmId(), isSuccess);
              if (isSuccess != null && !Objects.equals("track_calculate", isSuccess)) {
                String[] urlArr = isSuccess.split(",");
                if (urlArr.length > 0) {
                  if (urlArr.length == 1 && 
                    !Objects.equals("null", urlArr[0]))
                    stuAbnormalActionAlarm.setAlarmRelatePic(urlArr[0]); 
                  if (urlArr.length == 2) {
                    if (!Objects.equals("null", urlArr[0]))
                      stuAbnormalActionAlarm.setAlarmRelatePic(urlArr[0]); 
                    if (!Objects.equals("null", urlArr[1]))
                      stuAbnormalActionAlarm.setAlarmRelateMov(urlArr[1]); 
                  } 
                  if (StrUtil.isNotBlank(stuAbnormalActionAlarm.getAlarmRelatePic()) || StrUtil.isNotBlank(stuAbnormalActionAlarm.getAlarmRelateMov()))
                    this.stuAbnormalActionAlarmMapper.updateAlarmRelatePicAndAlarmRelateMov(stuAbnormalActionAlarm); 
                } 
              } 
            } 
          } 
        } 
      } 
      pushData.add(stuAbnormalActionAlarm);
    } 
    this.pushDataService.pushAbnormalToMsgCenter(pushData);
    this.abnormalManageService.pushAbnormalToWeCharUpgrade(pushData);
    logger.info("成功添加轨迹大小=" + result.size());
    return result;
  }
  
  private int getAreaType(String areaid) {
    if (StrUtil.isBlank(areaid))
      return 0; 
    List<ThirdAreaDto> allBuilding = this.serviceUtils.getAllBuilding();
    ThirdAreaDto thirdArea = allBuilding.stream().filter(v -> areaid.equals(String.valueOf(v.getBuildingId()))).findFirst().orElse(null);
    if (thirdArea != null)
      return ((thirdArea.getFlag().intValue() == 0) ? AreaTypeEnum.CODE4.code : AreaTypeEnum.CODE3.code).intValue(); 
    return 0;
  }
  
  private boolean ignoreThisAbnormal(String deviceId, String alarmTime, Integer actionTypeCode) {
    if (StrUtil.isBlank(deviceId) || StrUtil.isBlank(alarmTime) || actionTypeCode == null)
      return true; 
    Timestamp newAlarmTime = Timestamp.valueOf(alarmTime);
    List<StuAbnormalActionAlarm> stuAbnormalActionAlarms = this.stuAbnormalActionAlarmMapper.selectLastRecordByDeviceId(deviceId, actionTypeCode);
    if (CollectionUtils.isNotEmpty(stuAbnormalActionAlarms)) {
      StuAbnormalActionAlarm stuAbnormalActionAlarm = stuAbnormalActionAlarms.get(0);
      long betweenSecond = newAlarmTime.getTime() - stuAbnormalActionAlarm.getAlarmTime().getTime();
      return (betweenSecond < 60000L);
    } 
    return false;
  }
}
